<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) Business Edition 2.0.6                                  |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2010 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | Contentteller is not free software. You may not redistribute this file   |
// | or its derivatives without written permission.                           |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+
// | Build: 529.6.100301-115731                                               |
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage Articles
 * @copyright (C) 2002 - 2010 Esselbach Internet Solutions
 */

/**
 * function Articles
 * A function to edit a comment in the database
 * @author Philipp Louis Esselbach
 */
function ArticlesDoCommentEdit()
{
	global $database, $templates, $system, $preferences, $security, $user, $ipaddr;
	$input_subject = ( isset( $_POST[ 'input_subject' ] ) ) ? $security -> checkvar( $_POST[ 'input_subject' ] ) : "" ;
	$input_icon = ( isset( $_POST[ 'input_icon' ] ) ) ? $security -> checknum( $_POST[ 'input_icon' ] ) : 0 ;
	$input_signature = ( isset( $_POST[ 'input_signature' ] ) ) ? $security -> checknum( $_POST[ 'input_signature' ] ) : 0 ;
	$input_smilies = ( isset( $_POST[ 'input_smilies' ] ) ) ? $security -> checknum( $_POST[ 'input_smilies' ] ) : 0 ;
	$input_bcode = ( isset( $_POST[ 'input_bcode' ] ) ) ? $security -> checknum( $_POST[ 'input_bcode' ] ) : 0 ;
	$input_url = ( isset( $_POST[ 'input_url' ] ) ) ? $security -> checknum( $_POST[ 'input_url' ] ) : "" ;
	$input_message = ( isset( $_POST[ 'input_message' ] ) ) ? $security -> checkvar( $_POST[ 'input_message' ] ) : "" ;
	$input_preview = ( isset( $_POST[ 'input_preview' ] ) ) ? $security -> checkvar( $_POST[ 'input_preview' ] ) : "" ;
	$input_comment_id = ( isset( $_POST[ 'input_comment_id' ] ) ) ? $security -> checknum( $_POST[ 'input_comment_id' ] ) : "" ;
	$input_security_hash = ( isset( $_POST[ 'input_security_hash' ] ) ) ? $security -> checkvar( $_POST[ 'input_security_hash' ] ) : "" ;
	$main_templates = $templates -> preparetemplates( "'site_header','site_footer','site_block','site_login_anon','site_login_user','site_invalid_form','articles_summary_comment_header','articles_summary_comment_edit_done','articles_summary_comment_footer','articles_header','articles_footer','articles_error_banned','articles_error_nosubject','articles_error_nomessage','articles_error_editcomment','articles_error_edittime','articles_error_length','articles_error_na','articles_summary_comment_preview','articles_summary_comment_form_icon','articles_summary_comment_form_iconrow','articles_summary_comment_edit_form'", $preferences[ 'current_theme' ] );
	$insert = $system -> getinsert( $preferences, $main_templates );
	$insert[ 'page_name' ] = $preferences[ 'website_name' ];
	$insert[ 'page_description' ] = $preferences[ 'website_description' ];
	$insert[ 'page_keywords' ] = $preferences[ 'website_keywords' ];
	$templates -> initgzip();
	session_start();

	if( ( $_SESSION[ 'news_security_hash' ] != $input_security_hash ) and( $preferences[ 'website_subsessions_user' ] ) )
	{
		echo $templates -> exectemplate( $main_templates[ 'site_header_html' ], $main_templates[ 'site_header_php' ], $insert );
		echo $templates -> exectemplate( $main_templates[ 'site_invalid_form_html' ], $main_templates[ 'site_invalid_form_php' ], $insert );
		echo $templates -> exectemplate( $main_templates[ 'site_footer_html' ], $main_templates[ 'site_footer_php' ], $insert );
		exit;
	}
	else
	{
		$insert[ 'news_security_hash' ] = $input_security_hash;
	}

	echo $templates -> exectemplate( $main_templates[ 'site_header_html' ], $main_templates[ 'site_header_php' ], $insert );
	$query = $database -> dbquery( "SELECT articlecomment_author, articlecomment_article, UNIX_TIMESTAMP(articlecomment_date) FROM " . DB_PREFIX . "esselbach_ct_articlescomments WHERE articlecomment_id = '" . $input_comment_id . "'" );

	if( $database -> dbrows( $query ) )
	{
		list( $articlecomment_author, $articlecomment_article, $articlecomment_date ) = $database -> dbrow( $query );

		if( $user[ 'user_status' ] == 2 or $user[ 'user_status' ] == 3 or $articlecomment_author == $user[ 'user_name' ] )
		{
			$query = $database -> dbquery( "SELECT article_id, article_title, article_seo, article_allowcomments, article_status, article_date FROM " . DB_PREFIX . "esselbach_ct_articles WHERE article_id = '" . intval( $articlecomment_article ) . "'" );

			if( $database -> dbrows( $query ) )
			{
				list( $insert[ 'article_id' ], $insert[ 'article_title' ], $insert[ 'article_seo' ], $insert[ 'article_allowcomments' ], $insert[ 'article_status' ], $insert[ 'article_date' ] ) = $database -> dbrow( $query );
				$insert[ 'article_title' ] = htmlspecialchars( $insert[ 'article_title' ] );
				if( $preferences[ 'articles_navigation' ] )
				{
					echo $templates -> exectemplate( $main_templates[ 'articles_summary_comment_header_html' ], $main_templates[ 'articles_summary_comment_header_php' ], $insert );
				}

				if( $input_icon )
				{
					$database -> dbquery( "SELECT messageicon_id FROM " . DB_PREFIX . "esselbach_ct_messageicons WHERE messageicon_id = '" . intval( $input_icon ) . "'" );

					if( !$database -> dbrows( $query ) )
					{
						$input_icon = 0;
					}
				}
				else
				{
					$input_icon = 0;
				}

				if( $user[ 'user_status' ] == 5 )
				{
					$error = $templates -> exectemplate( $main_templates[ 'articles_error_banned_html' ], $main_templates[ 'articles_error_banned_php' ], $insert );
				}
				elseif( !$input_subject )
				{
					$error = $templates -> exectemplate( $main_templates[ 'articles_error_nosubject_html' ], $main_templates[ 'articles_error_nosubject_php' ], $insert );
				}
				elseif( !$input_message )
				{
					$error = $templates -> exectemplate( $main_templates[ 'articles_error_nomessage_html' ], $main_templates[ 'articles_error_nomessage_php' ], $insert );
				}
				else
				{
					$query = $database -> dbquery( "SELECT UNIX_TIMESTAMP()" );
					list( $articlecomment_currentdate ) = $database -> dbrow( $query );
					$articlecomment_editdate = $articlecomment_date + $preferences[ 'articles_max_edittime' ];

					if( $articlecomment_currentdate > $articlecomment_editdate )
					{
						$insert[ 'articlecomment_editseconds' ] = $preferences[ 'articles_max_edittime' ];
						$error = $templates -> exectemplate( $main_templates[ 'articles_error_edittime_html' ], $main_templates[ 'articles_error_edittime_php' ], $insert );
					}
				}

				if( strlen( $input_message ) < $preferences[ 'articles_min_commentlength' ] )
				{
					$insert[ 'articlecomment_length' ] = $preferences[ 'articles_min_commentlength' ];
					$error = $templates -> exectemplate( $main_templates[ 'articles_error_length_html' ], $main_templates[ 'articles_error_length_php' ], $insert );
				}

				if( !$insert[ 'article_allowcomments' ] )
				{
					$error = $templates -> exectemplate( $main_templates[ 'articles_error_nocomments_html' ], $main_templates[ 'articles_error_nocomments_php' ], $insert );
				}
			}
			else
			{
				$error = $templates -> exectemplate( $main_templates[ 'articles_error_na_html' ], $main_templates[ 'articles_error_na_php' ], $insert );
			}

			$insert[ 'input_subject' ] = "";
			$insert[ 'input_message' ] = "";

			if( $preferences[ 'articles_allow_msgicons' ] )
			{
				$query = $database -> dbquery( "SELECT messageicon_id, messageicon_name, messageicon_image FROM " . DB_PREFIX . "esselbach_ct_messageicons WHERE messageicon_active = '1' ORDER BY messageicon_position" );
				$messageicon_row = 0;
				$insert[ 'article_iconrow' ] = "";

				while( list( $insert[ 'messageicon_id' ], $insert[ 'messageicon_name' ], $insert[ 'messageicon_image' ] ) = $database -> dbrow( $query ) )
				{
					if( !$messageicon_row )
					{
						$insert[ 'messageicon_checked' ] = "checked=\"checked\"";
					}
					else
					{
						$insert[ 'messageicon_checked' ] = "";
					}

					$messageicon_row++;

					if( $messageicon_row > $preferences[ 'articles_max_msgicons' ] )
					{
						$insert[ 'messageicon_break' ] = "<br />";
						$messageicon_row = 1;
					}
					else
					{
						$insert[ 'messageicon_break' ] = "";
					}

					$insert[ 'article_iconrow' ] .= $templates -> exectemplate( $main_templates[ 'articles_summary_comment_form_iconrow_html' ], $main_templates[ 'articles_summary_comment_form_iconrow_php' ], $insert );
				}
			}

			if( $insert[ 'article_iconrow' ] )
			{
				$insert[ 'article_icon' ] = $templates -> exectemplate( $main_templates[ 'articles_summary_comment_form_icon_html' ], $main_templates[ 'articles_summary_comment_form_icon_php' ], $insert );
			}
			else
			{
				$insert[ 'article_icon' ] = "";
			}

			( $input_signature ) ? $insert[ 'input_signature_checked' ] = "checked=\"checked\"" : $insert[ 'input_signature_checked' ] = "" ;
			( $input_smilies ) ? $insert[ 'input_smilies_checked' ] = "checked=\"checked\"" : $insert[ 'input_smilies_checked' ] = "" ;
			( $input_bcode ) ? $insert[ 'input_bcode_checked' ] = "checked=\"checked\"" : $insert[ 'input_bcode_checked' ] = "" ;
			$insert[ 'articlecomment_id' ] = $input_comment_id;

			if( isset( $error ) )
			{
				echo $error;
				$insert[ 'input_subject' ] = stripslashes( $input_subject );
				$insert[ 'input_message' ] = stripslashes( $input_message );
				echo $templates -> exectemplate( $main_templates[ 'articles_summary_comment_edit_form_html' ], $main_templates[ 'articles_summary_comment_edit_form_php' ], $insert );
				unset( $error );
			}
			else
			{
				if( !$input_url )
				{
					$input_url = 0;
				}
				else
				{
					$input_message = preg_replace( "#(^|[\n ])([\w]+?://[^ \"\n\r\t<]*)#is", "\\1[url]\\2[/url]", $input_message );
				}

				$input_message_parsed = stripslashes( $input_message );			
				$input_message_parsed = $system -> dechomp( $input_message_parsed );

				if( !$input_smilies )
				{
					$input_message_parsed = $system -> smilies( $input_message_parsed );
				}

				if( !$input_bcode )
				{
					$input_message_parsed = $system -> code( $input_message_parsed );
				}

				if( $preferences[ 'articles_comment_censor' ] )
				{
					$censored_words = explode( " ", $preferences[ 'articles_comment_censor' ] );

					for( $i = 0; $i < count( $censored_words ); $i++ )
					{
						$censor = str_repeat( "*", strlen( $censored_words[ $i ] ) );
						$input_message_parsed = preg_replace( "/" . $censored_words[ $i ] . "/i", $censor, $input_message_parsed );
					}
				}

				if( $input_preview )
				{
					$insert[ 'input_subject' ] = htmlspecialchars( stripslashes( $input_subject ) );
					$insert[ 'input_message' ] = $input_message_parsed;
					echo $templates -> exectemplate( $main_templates[ 'articles_summary_comment_preview_html' ], $main_templates[ 'articles_summary_comment_preview_php' ], $insert );
					$insert[ 'input_message' ] = stripslashes( $input_message );
					echo $templates -> exectemplate( $main_templates[ 'articles_summary_comment_edit_form_html' ], $main_templates[ 'articles_summary_comment_edit_form_php' ], $insert );
				}
				else
				{
					$input_message_parsed = $database -> dbescape( $input_message_parsed );

					if( $preferences[ 'articles_comment_history' ] )
					{
						$query = $database -> dbquery( "SELECT articlecomment_author, articlecomment_subject, articlecomment_text, articlecomment_date FROM " . DB_PREFIX . "esselbach_ct_articlescomments WHERE articlecomment_id = '" . $input_comment_id . "'" );
						list( $history_author, $history_subject, $history_text, $history_date ) = $database -> dbrow( $query );
						$history_author = $database -> dbescape( $history_author );
						$history_subject = $database -> dbescape( $history_subject );
						$history_text = $database -> dbescape( $history_text );
						$history_date = $database -> dbescape( $history_date );
						$lasteditauthor = $database -> dbescape( $user[ 'user_name' ] );
						$database -> dbquery( "INSERT INTO " . DB_PREFIX . "esselbach_ct_articlescommentshistory (articlecommenthistory_id, articlecommenthistory_author, articlecommenthistory_comment, articlecommenthistory_subject, articlecommenthistory_text, articlecommenthistory_date, articlecommenthistory_postip) VALUES (NULL, '" . $history_author . "', '" . $input_comment_id . "', '" . $history_subject . "', '" . $history_text . "', '" . $history_date . "', '" . $ipaddr . "')" );
					}

					$database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_articlescomments SET articlecomment_subject = '" . $input_subject . "', articlecomment_rawtext = '" . $input_message . "', articlecomment_text = '" . $input_message_parsed . "', articlecomment_signature = '" . $input_signature . "', articlecomment_smilies = '" . $input_smilies . "', articlecomment_bcode = '" . $input_bcode . "', articlecomment_edits = articlecomment_edits + 1, articlecomment_lasteditauthor = '" . $lasteditauthor . "', articlecomment_lasteditdate = now(), articlecomment_editip = '" . $ipaddr . "' WHERE articlecomment_id = '" . $input_comment_id . "'" );
					echo $templates -> exectemplate( $main_templates[ 'articles_summary_comment_edit_done_html' ], $main_templates[ 'articles_summary_comment_edit_done_php' ], $insert );
				}
			}

			if( $preferences[ 'articles_navigation' ] )
			{
				echo $templates -> exectemplate( $main_templates[ 'articles_summary_comment_footer_html' ], $main_templates[ 'articles_summary_comment_footer_php' ], $insert );
			}
		}
		else
		{
			$error = $templates -> exectemplate( $main_templates[ 'articles_error_nopermission_html' ], $main_templates[ 'articles_error_nopermission_php' ], $insert );
		}
	}
	else
	{
		$error = $templates -> exectemplate( $main_templates[ 'articles_error_editcomment_html' ], $main_templates[ 'articles_error_editcomment_php' ], $insert );
	}

	if( isset( $error ) )
	{
		if( $preferences[ 'articles_navigation' ] )
		{
			echo $templates -> exectemplate( $main_templates[ 'articles_header_html' ], $main_templates[ 'articles_header_php' ], $insert );
		}

		echo $templates -> exectemplate( $main_templates[ 'articles_error_na_html' ], $main_templates[ 'articles_error_na_php' ], $insert );

		if( $preferences[ 'articles_navigation' ] )
		{
			echo $templates -> exectemplate( $main_templates[ 'articles_footer_html' ], $main_templates[ 'articles_footer_php' ], $insert );
		}
	}

	echo $templates -> exectemplate( $main_templates[ 'site_footer_html' ], $main_templates[ 'site_footer_php' ], $insert );
}
?>